class Tag < ApplicationRecord
  has_many :post_tags, dependent: :destroy
  has_many :posts, through: :post_tags
  has_many :tag_aliases, dependent: :destroy
  has_many :wiki_pages, dependent: :nullify

  validates :name, presence: true, length: { maximum: 255 }
  validates :category, presence: true, inclusion: { in: categories.keys }

  enum category: { deerjikist:  'deerjikist',
                   meme:        'meme',
                   character:   'character',
                   general:     'general',
                   material:    'material',
                   nico:        'nico',
                   meta:        'meta' }

  scope :nico_tags, -> { where category: :nico }
end
